#include "enemy.h"
#include "graphics.h"
#include "level.h"

#include<stdlib.h>
#include<math.h>

CEnemy *CEnemy::Instance = NULL;

void CEnemy::init(DATAFILE *theFile)
{
    Instance = new CEnemy(theFile);
}

CEnemy::CEnemy(DATAFILE *theFile)
{
    theDatFile = theFile;
    max = 0;
}

CEnemy::~CEnemy()
{
    for(vector<CAnimation *>::iterator i = animations.begin(); i != animations.end(); i++)
    {
        delete *i;
    }
}

void CEnemy::draw()
{
    for(int i = 0; i < max; i++)
        draw_sprite(CGraphics::instance()->getDB(), animations[i]->getCurr(), (int)xVals[i] + CGraphics::instance()->offX, (int)yVals[i] + CGraphics::instance()->offY);
}

void CEnemy::update(CPlayer *playa)
{
    for(int i = 0; i < max; i++)
    {
        tVals[i]++;
        //update location
        float alpha = (float)atan2((double)(yVals[i] - playa->getY()), (double)(xVals[i] - playa->getX()));
        xVals[i] -= vVals[i] * cos(alpha);
        yVals[i] -= vVals[i] * sin(alpha);
        
        //add sine movement
        xVals[i] -= sin((tVals[i] * 0.0174532925)) * vVals[i] * cos(alpha + 1.57079633);
        yVals[i] -= sin((tVals[i] * 0.0174532925)) * vVals[i] * sin(alpha + 1.57079633);
        
        animations[i]->update();
        //check collision
        if(playa->checkCollision((int)xVals[i], (int)yVals[i], animations[i]->getCurr()->h, animations[i]->getCurr()->w))
        {
            //change location + damage samus
            playa->takeHit();
            xVals[i] = rand() % (w * 32);
            yVals[i] = rand() % (h * 32);
            vVals[i] = (float)(rand() % 80)/(float)100 + 0.1f;
            tVals[i] = rand() % 360;
            animations[i]->reset();
        }
    }
}

void CEnemy::setNumber(int to, Clevel *mappy)
{
    for(vector<CAnimation *>::iterator i = animations.begin(); i != animations.end(); i++)
        delete *i;
        
    animations.clear();
    xVals.clear();
    yVals.clear();
    max = to;
    w = mappy->getWidth();
    h = mappy->getHeight();
    for(int i = 0; i < to; i++)
    {
        animations.push_back(new CAnimation(theDatFile, rand() % 30 + 30));
        xVals.push_back(rand() % (w * 32));
        yVals.push_back(rand() % (h * 32));
        tVals.push_back(rand() % 360);
        vVals.push_back((float)(rand() % 100)/(float)100);
    }
}
