#ifndef PREPROCPLAYERHEADER
#define PREPROCPLAYERHEADER

#include<allegro.h>
#ifdef WIN32
    #include<winalleg.h>
#endif

#include<vector>
using namespace std;

#include "animation.h"
#include "level.h"

#define PLAYER_STAND 0
#define PLAYER_WALL_HOLD 2
#define PLAYER_TURN 4
#define PLAYER_JUMP 6
#define PLAYER_RUN 8

#define inputLeft 1
#define inputRight 2
#define inputJump 4

class Clevel;

class CPlayer
{
public:
    CPlayer(DATAFILE *);
    ~CPlayer();
    
    void draw();
    void update(int input, Clevel *theMap);
    
    void setPlayerAction(int to, bool right);
    
    void setX(int to);
    void setY(int to);
    
    float getX() {return x;};
    float getY() {return y;};
    
    void takeHit() {life -= 2;};
    int getLife() {return life;};
    
    bool checkCollision(int wx, int wy, int ww, int wh);
protected:
    int currAction;
    bool facingRight;
    float velocityX, velocityY;
    float x, y;
    float groundAccel, airAccel, groundFriction, airFriction, jumpSpeed, maxXV, maxYV;
    vector<CAnimation *> animations;
    int nonLoopAnimationTime;
    int currNonTime;
    bool onGround;
    int onRightWall;
    int onLeftWall;
    int leftHold;
    int rightHold;
    bool waitingForLeftHoldTimeout;
    bool waitingForRightHoldTimeout;
    int life; //current life out of 100
    int lifeRegenCounter;
};

#endif
